declare module redux-postmessage-middleware
{
	export const actionType: (type: string) => string;
	export const isLocalAction: (action: any) => boolean;

	export const ACTION_PREFIX = "@redux-postmessage";
	export const REMOTE_ACTION: symbol;

	export { actionType } from './action-helpers';
	export const createMessageDispatcherMiddleware: ({senderURL, parentURL, targetURLs}: {
	    senderURL: string;
	    parentURL?: string | undefined;
	    targetURLs?: string[] | undefined;
	}) => () => (next: Dispatch) => (action: any) => void;
	export const createMessageRecieverMiddleware: ({allowedURLs}: {
	    allowedURLs: string[];
	}) => (store: Store) => (next: Dispatch) => (action: any) => void;

	export { createMessageDispatcher, MessageDispatcher } from './message-dispatcher';
	export { createMessageToActionHandler, MessageToActionHandler } from './message-handler';

	export type MessageDispatcher = (action: any) => void;
	export const createMessageDispatcher: ({window, document, senderURL, parentURL, targetURLs}: {
	    window: Window;
	    document: Document;
	    senderURL: string;
	    parentURL?: string | undefined;
	    targetURLs?: string[] | undefined;
	}) => MessageDispatcher;

	export type ActionHandler = (action: any) => void;
	export type MessageHandler = (ev: MessageEvent) => void;
	export type MessageToActionHandler = (fn: ActionHandler) => MessageHandler;
	export const createMessageToActionHandler: ({allowedURLs}: {
	    allowedURLs: string[];
	}) => MessageToActionHandler;

	export function parseURL(url: string, document: Document): string[];
	export function buildURL(protocol: string, hostname: string, port?: string, pathname?: string): string;
	export function getOrigin(loc: any): string;
	export const originFromURL: (document: Document) => (url: string) => string;
	export const isString: (value: any) => boolean;

	export { MessageDispatcherMiddleware } from './message-dispatcher-middleware';
	export { MessageRecieverMiddleware } from './message-reciever-middleware';

	/// <reference path="../../src/middlewares/index.d.ts" />
	import { MessageDispatcher } from '../messaging';
	export const MessageDispatcherMiddleware: ({dispatch}: {
	    dispatch: MessageDispatcher;
	}) => () => (next: Dispatch) => (action: any) => void;

	/// <reference path="../../src/middlewares/index.d.ts" />
	import { MessageToActionHandler } from '../messaging';
	export const MessageRecieverMiddleware: ({messageToActionHandler}: {
	    messageToActionHandler: MessageToActionHandler;
	}) => (store: Store) => (next: Dispatch) => (action: any) => void;

}